#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>
#include <String.h>

//declaratii variabile
bool testDeplasareInainte = false;
bool testDeplasareInapoi = false;
int nrPasiDeplasare = 0;
int pasDeplasare =0;
int nrPasi = 0;

//declaratii pini
const int temperaturaInt = 2;
const int temperaturaExt = 1;
const int deplasare1 = 10;
const int deplasare2 = 9;
const int deplasare3 = 8;
const int deplasare4 = 7;

const int motorUsa1 = 11; //i1 si i2
const int motorUsa2 = 12; //i3 si i4

const int pinLumina = 2; 

const int tensPompa = 4; //alimentare pompa sau ventilator
const int selPompa = 3; //LOW-pompa, HIGH-ventilatie

const int tensMotor2_3 = 6;
const int selMotor2_3 = 5;

const int pinFereastra = 1;

const int enableUsa = 13;

int pasDeplasareMotorGaraj = 0; //pozitia initiala a rotorului motorului de deplasare
int pasDeplasareMotorGeam = 0; //pozitia initiala a rotorului motorului de deplasare
int vDeplasare[4][4] = {{HIGH, LOW, LOW, LOW}, {LOW, HIGH, LOW, LOW}, {LOW, LOW, HIGH, LOW}, {LOW, LOW, LOW, HIGH}};

//int vDeplasare1[4][2] = {{HIGH, HIGH}, {HIGH, LOW}, {LOW, LOW}, {LOW, HIGH}};
int vDeplasare1[4][2] = {{HIGH, HIGH}, {HIGH, LOW}, {LOW, LOW}, {LOW, HIGH}};
int pasDeplasare1 = 0;


void setup() {
  // put your setup code here, to run once:
 // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect
  }
    //configurare pini
  pinMode(1, INPUT);  //senzor-detectie capat banda de deplasare
  pinMode(2, OUTPUT); //pt dozare
  digitalWrite(2, HIGH);
  pinMode(3, OUTPUT); //incarcare cutii mari
  pinMode(4, OUTPUT); //incarcare cutii mari
  pinMode(5, OUTPUT); //incarcare cutii mici
  pinMode(6, OUTPUT); //incarcare cutii mici
  pinMode(7, OUTPUT); //motor deplasare
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT); //I4 si I3 motor sortare
  pinMode(12, OUTPUT); //I1 si I2 motor sortare
  pinMode(13, OUTPUT); //enable L293D-motor sortare

   //setare pini

  digitalWrite(deplasare1, LOW);
  digitalWrite(deplasare2, LOW);
  digitalWrite(deplasare3, LOW);
  digitalWrite(deplasare4, LOW);

  digitalWrite(tensPompa, LOW);
  digitalWrite(selPompa, LOW);
  digitalWrite(tensMotor2_3, LOW);
  digitalWrite(selMotor2_3, LOW);

  digitalWrite(enableUsa, LOW);
  digitalWrite(motorUsa1, HIGH);
  digitalWrite(motorUsa2, HIGH);
  afiseazaOptiuni();
 
}

void afiseazaOptiuni() {
  Serial.write("Comenzi disponibile:\n");
  Serial.write("H - afisare comenzi disponibile: \n");
  Serial.write("T - Afisare temperatura interioara si exterioara \n");
  Serial.write("Un - deplasare usa intrare cu n pasi (recomandat +-40)\n");
  Serial.write("Fn - deplasare fereastra cu n pasi (recomandat +-20)\n");
  Serial.write("Gn - deplasare usa garaj cu n pasi (recomandat +-350)\n");
  Serial.write("P - actionare sistem de incalzire 10s \n");
  Serial.write("V - actionare sistem de ventilatie 10s \n");
  Serial.write("L - Aprindere lumina 10s \n");
  Serial.write("S - Citire stare senzori de temperatura si fereastra inchisa \n");
  Serial.write("\n");
 
}
void loop() {
  // put your main code here, to run repeatedly:
  //testare prin Serial Monitor
  if (Serial.available()) {

    String com = Serial.readString();
    char comanda = com.charAt(0)&0xDF;   //se forteaza litere mari NOT 20H
    String param;
    int parametru;
    
    switch (comanda) {
     case 'H':
        afiseazaOptiuni();
        break;
     case 'G' :    //actionare usa garaj
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Usa garajului se deplaseaza cu");
            Serial.print(parametru);
            Serial.print(" pasi!\n");
            nrPasi = parametru;
            Deplasare(nrPasi,3);
          }
        }
        break;
      case 'F' :    //actionare fereastra
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Fereastra se deplaseaza cu");
            Serial.print(parametru);
            Serial.print(" pasi!\n");
            nrPasi = parametru;            
            Deplasare(nrPasi,2);
           }
        }
        break;
        case 'L' :       //actionare lumini
        {
         digitalWrite(pinLumina, LOW);
         Serial.println("Aprindere lumina");
         delay(10000);
          digitalWrite(pinLumina, HIGH);
         Serial.println("Stingere lumina");
        }
        break;
        case 'U' :      //actionare usa intrare
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Usa se deplaseaza cu");
            Serial.print(parametru);
            Serial.print(" pasi!\n");
            nrPasi = parametru;
            DeplasareUsa();
            
            }
         }
         break;
         case 'P' :      //actionare pompa de incalzire
        {
         digitalWrite(tensPompa, HIGH);
         digitalWrite(selPompa, LOW);
         Serial.println("Pornire incalzire");
         delay(10000);
         digitalWrite(tensPompa, LOW);
         digitalWrite(selPompa, LOW);
         Serial.println("Oprire incalzire");
        }
        break;
       case 'V' :    //actionare ventilator
        {
         digitalWrite(tensPompa, HIGH);
         digitalWrite(selPompa, HIGH);
         Serial.println("Pornire ventilatie");
         delay(10000);
         digitalWrite(tensPompa, LOW);
         digitalWrite(selPompa, LOW);
         Serial.println("Oprire ventilatie");
        }
        break;
        case 'T' :   //citire temperatura
        {
         Serial.println("Temperatura interioara este:");
         float t=analogRead(temperaturaInt)*5000./1024/10;
         Serial.println(t);
         Serial.println("Temperatura exterioara este:");
         t=analogRead(temperaturaExt)*5000./1024/10;
         Serial.print(t);
         Serial.println(" grade Celsius");
        }
        break;
        case 'S' :   //citire stare: temperatura si stare fereastra
        {
         Serial.println("Temperatura interioara este:");
         float t=analogRead(temperaturaInt)*5000./1024/10;
         Serial.println(t);
         Serial.println("Temperatura exterioara este:");
         t=analogRead(temperaturaExt)*5000./1024/10;
         Serial.print(t);
         Serial.println(" grade Celsius");
         if(digitalRead(pinFereastra))
           Serial.println("Fereastra deschisa");
           else
           Serial.println("Fereastra inchisa");
        }
        break;
      }
  }
}

void Deplasare(int Pasi, int motor){
 if(motor==2)
   { digitalWrite(selMotor2_3, LOW);
    digitalWrite(tensMotor2_3, HIGH);}
  else   //motor 3
     {digitalWrite(selMotor2_3, HIGH);
      digitalWrite(tensMotor2_3, HIGH);}
 if(Pasi>0)
  {//deplasare inainte
    nrPasiDeplasare=Pasi;
    while(nrPasiDeplasare>0)
    { 
      pasDeplasare = (pasDeplasare - 1) % 4;
      if (pasDeplasare < 0)
      {
      pasDeplasare = pasDeplasare + 4;
      }
      digitalWrite(deplasare1, vDeplasare[pasDeplasare][0]);
      digitalWrite(deplasare2, vDeplasare[pasDeplasare][1]);
      digitalWrite(deplasare3, vDeplasare[pasDeplasare][2]);
      digitalWrite(deplasare4, vDeplasare[pasDeplasare][3]);
      delay(10);
      nrPasiDeplasare = nrPasiDeplasare - 1;
      ;Serial.println(nrPasiDeplasare);
    }
    testDeplasareInainte = false;
 }
  else //if(Pasi<0)
   {//deplasare inapoi
   nrPasiDeplasare=-Pasi;
    while(nrPasiDeplasare>0)
    {
      pasDeplasare = (pasDeplasare + 1) % 4;
      digitalWrite(deplasare1, vDeplasare[pasDeplasare][0]);
      digitalWrite(deplasare2, vDeplasare[pasDeplasare][1]);
      digitalWrite(deplasare3, vDeplasare[pasDeplasare][2]);
      digitalWrite(deplasare4, vDeplasare[pasDeplasare][3]);
      nrPasiDeplasare = nrPasiDeplasare - 1;
      delay(10);
    }
    testDeplasareInapoi = false;
  }
 
  digitalWrite(deplasare1, LOW);
  digitalWrite(deplasare2, LOW);
  digitalWrite(deplasare3, LOW);
  digitalWrite(deplasare4, LOW);
  digitalWrite(tensMotor2_3, LOW);
  digitalWrite(selMotor2_3, LOW);
        
}

void DeplasareUsa()
{
 if(nrPasi>0)
  {//deplasare inainte
    digitalWrite(enableUsa, HIGH);
    nrPasiDeplasare=nrPasi;
    while(nrPasiDeplasare>0)
    { 
      pasDeplasare1 = (pasDeplasare1 - 1) % 4;
      if (pasDeplasare1 < 0)
      {
      pasDeplasare1 = pasDeplasare1 + 4;
      }
      digitalWrite(motorUsa1, vDeplasare1[pasDeplasare1][0]);
      digitalWrite(motorUsa2, vDeplasare1[pasDeplasare1][1]);
      delay(20);
      nrPasiDeplasare = nrPasiDeplasare - 1;
      Serial.println(nrPasiDeplasare);
    }
    testDeplasareInainte = false;
 }
  else //if(nrPasi<0)
   {//deplasare inapoi
    digitalWrite(enableUsa, HIGH);
     nrPasiDeplasare=-nrPasi;
    while(nrPasiDeplasare>0)
    {
      pasDeplasare1 = (pasDeplasare1 + 1) % 4;
      digitalWrite(motorUsa1, vDeplasare1[pasDeplasare1][0]);
      digitalWrite(motorUsa2, vDeplasare1[pasDeplasare1][1]);
      nrPasiDeplasare = nrPasiDeplasare - 1;
      delay(20);
    }
//    testDeplasareInapoi = false;
  }
  digitalWrite(enableUsa, LOW);
}

