#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>
#include <String.h>
//declaratii pentru starea sistemului
bool testSortareStanga = false;
bool testSortareDreapta = false;
bool testDeplasareInainte = false;
bool testDeplasareInapoi = false;
int nrPasiDeplasare = 0;
int nrPasiSortare = 0;
bool testDozare = false;
int bileDozare = 0;
int stareDozare = 0;
int delayDozare = 0;
bool testIncarcareCMica = false;
bool testIncarcareCMare = false;
int delayIncarcare = 0;
int stareIncarcare = 0;
int delaySortare = 0;
int stareSortare = 0;
int stareDeplasare = 0;
int delayDeplasare = 0;
bool testProcesAutomat = false;
int nrCutiiMici = 0;
int nrCutiiMari = 0;
int nrBileMici = 0;
int nrBileMari = 0;
int stareProces = 0;
int delayProces = 0;
int delayInitializare = 0;
bool eCutiePeLinie = false;
bool gasitCutie = false;
bool capatLinieDeplasare = false;
int ultimaCutieEronata = -1; //nu exista cutii eronate
bool afiseazaRaportInSerialMonitor = false;


//variabile pentru generare raport
int cutiiMiciEronate = 0;
int cutiiMariEronate = 0;
int cutiiMiciIncarcate = 0;
int cutiiMariIncarcate = 0;
int bileMiciDozate = 0;
int bileMariDozate = 0;
bool afiseazaRaport = false;

String paginaCurenta = "";

//declaratii pini
const int deplasare1 = 10;
const int deplasare2 = 9;
const int deplasare3 = 8;
const int deplasare4 = 7;

const int sortare1 = 11; //i1 si i2
const int sortare2 = 12; //i3 si i4

const int pinDozare = 2;

const int pinCutMica1 = 6;
const int pinCutMica2 = 5;

const int pinCutMare1 = 4;
const int pinCutMare2 = 3;

const int pinSenzorDetectie = 1;

const int enableSortare = 13;

int pasDeplasare = 0; //pozitia initiala a rotorului motorului de deplasare
int vDeplasare[4][4] = {{HIGH, LOW, LOW, LOW}, {LOW, HIGH, LOW, LOW}, {LOW, LOW, HIGH, LOW}, {LOW, LOW, LOW, HIGH}};

int vSortare[4][2] = {{HIGH, HIGH}, {HIGH, LOW}, {LOW, LOW}, {LOW, HIGH}};
int pasSortare = 0;

byte mac[] = {
  0x98, 0x4F, 0xEE, 0x00, 0x49, 0x6F
};
//IPAddress ip(192, 168, 0, 7); //camin
//IPAddress ip(192, 168, 0, 250);//facultate
//IPAddress ip(172, 27, 11, 79);//sala de lectura
//IPAddress ip(192, 168, 2, 250); //alex
String request;
bool userAutentificat = false;
bool ipSetat;
EthernetServer server(80);
File webFile;
//variabile pentru stocare request+username&password
char linebuf[80];
int charcount = 0;
int initialSensorValue = 0;

void setup()
{
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect
  }
  paginaCurenta = "";
  ipSetat = false;
  //configurare pini
  pinMode(1, INPUT);  //senzor-detectie capat banda de deplasare
  pinMode(2, OUTPUT); //pt dozare
  digitalWrite(2, HIGH);
  pinMode(3, OUTPUT); //incarcare cutii mari
  pinMode(4, OUTPUT); //incarcare cutii mari
  pinMode(5, OUTPUT); //incarcare cutii mici
  pinMode(6, OUTPUT); //incarcare cutii mici
  pinMode(7, OUTPUT); //motor deplasare
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT); //I4 si I3 motor sortare
  pinMode(12, OUTPUT); //I1 si I2 motor sortare
  pinMode(13, OUTPUT); //enable L293D-motor sortare

  //setare pini

  digitalWrite(deplasare1, LOW);
  digitalWrite(deplasare2, LOW);
  digitalWrite(deplasare3, LOW);
  digitalWrite(deplasare4, LOW);

  digitalWrite(pinCutMica1, LOW);
  digitalWrite(pinCutMica2, LOW);
  digitalWrite(pinCutMare1, LOW);
  digitalWrite(pinCutMare2, LOW);

  digitalWrite(enableSortare, LOW);
  digitalWrite(sortare1, LOW);
  digitalWrite(sortare2, LOW);


  Serial.println("Sistemul poate fi controlat in doua moduri:");
  Serial.println("1.De la distanta. Setati adresa IP  a serverului.");
  Serial.println("Pentru acest lucru introduceti tasta S urmata de adresa IP");
  Serial.println("Ex: S192.168.1.4");
  Serial.println(" Apoi introduceti intr-un web browser aceasta adresa!");
  Serial.println("2.Trimiteti comenzi direct din Serial Monitor.");
  Serial.println("Pentru a vizualiza comenzile disponibile apasati tasta H!");



  // initialize SD card
  // Serial.println("Se initializeaza cardul SD...");
  if (!SD.begin())
  {
    Serial.println("ERROR - initializarea cardului a esuat!");
    return;    // init failed
  }
  // check for index.html file
  if (!SD.exists("index.html"))
  {
    Serial.println("ERROR -nu s-a gasit fisierul index.html!");
    return;
  }
  if (!SD.exists("testare.html"))
  {
    Serial.println("ERROR -nu s-a gasit fisierul testare.html!");
    return;
  }
  if (!SD.exists("info.html"))
  {
    Serial.println("ERROR -nu s-a gasit fisierul info.html!");
    return;
  }
  if (!SD.exists("manual.html"))
  {
    Serial.println("ERROR -nu s-a gasit fisierul manual.html!");
    return;
  }
}
void afiseazaOptiuni() {
  Serial.write("Comenzi disponibile:\n");
  Serial.write("Dn - dozarea unei cutii cu n bile Ex: D3=dozare 3 bile \n");
  Serial.write("c - incarcare cutie mica \n");
  Serial.write("C - incarcare cutie mare \n");
  Serial.write("Rn - deplasare DREAPTA a bratului de sortare cu n pasi \n");
  Serial.write("\tEx:R100=deplasare 100 de pasi la dreapta\n");
  Serial.write("Ln - deplasare STANGA a bratului de sortare cu n pasi\n");
  Serial.write("\tEx:L100=deplasare 100 de pasi la stanga\n");
  Serial.write("Fn- deplasarea INAINTE a mesei de deplasare cu n pasi\n");
  Serial.write("\tEx:F100=deplasare 100 de pasi inainte\n");
  Serial.write("Bn- deplasarea INAPOI a mesei de deplasare cu n pasi \n");
  Serial.write("\tEx:B100=deplasare 100 de pasi inapoi\n");
  Serial.write("PcXbXCXBX -efectuarea unui proces automat\n");
  Serial.write("\tEx:Pc2b3C4B5-incarca 2 cutii mici cu 3 bile si 4 cutii mari cu 5 bile \n");
}

void SendAuthentificationPage(EthernetClient &client)
{
  client.println("HTTP/1.1 401 Authorization Required");
  client.println("WWW-Authenticate: Basic realm=\"Secure Area\"");
  client.println("Content-Type: text/html");
  client.println("Connnection: close");
  client.println();
  client.println("<!DOCTYPE HTML>");
  client.println("<HTML>  <HEAD>   <TITLE>Error</TITLE>");
  client.println(" </HEAD> <BODY><H1>401 Unauthorized.</H1></BODY> </HTML>");
}

void loop()
{
  //testare prin Serial Monitor
  if (Serial.available()) {

    String com = Serial.readString();
    char comanda = com.charAt(0);
    String param;
    int parametru;
    String sparamCutMici;
    String sparamCutMari;
    String sparamBileMici;
    String sparamBileMari;

    switch (comanda) {
      case 'S' :
        if (ipSetat == true )
        {
          Serial.println("IP-ul a fost deja setat!!!");
        }
        else
        { String ipIntermediar = "";
          int ip1 = (com.substring(1, com.indexOf("."))).toInt();
          ipIntermediar = com.substring(com.indexOf(".") + 1, com.length());
          int ip2 = (ipIntermediar.substring(0, ipIntermediar.indexOf("."))).toInt();
          ipIntermediar = ipIntermediar.substring(ipIntermediar.indexOf(".") + 1, ipIntermediar.length());
          int ip3 = (ipIntermediar.substring(0, ipIntermediar.indexOf("."))).toInt();
          ipIntermediar = ipIntermediar.substring(ipIntermediar.indexOf(".") + 1, ipIntermediar.length());
          int ip4 = (ipIntermediar.substring(0, ipIntermediar.indexOf("."))).toInt();

          if (ip1 == 0 || ip2 == 0 || ip3 == 0 || ip4 == 0)
          {
            Serial.println("IP-ul introdus este gresit!");
          }
          else
          {
            IPAddress ip(ip1, ip2, ip3, ip4);// acasa
            // start the Ethernet connection and the server:
            Ethernet.begin(mac, ip);
            server.begin();
            Serial.print("Serverul se afla la adresa: ");
            Serial.println(Ethernet.localIP());
            Serial.println("Ip setat cu succes!");
            ipSetat = true;
          }
        }
        break;
      case 'H':
        afiseazaOptiuni();
        break;

      case 'D' :
        if (testDozare == true || testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Se dozeaza ");
            Serial.print(parametru);
            Serial.print("bile!\n");
            bileDozare = parametru;
            testDozare = true;
          }
        }
        break;

      case 'c' :
        Serial.write("Se incarca o cutie mica...\n");
        testIncarcareCMica = true;
        break;

      case 'C' :
        Serial.write("Se incarca o cutie mare...\n");
        testIncarcareCMare = true;
        break;

      case 'R' :
        if (testSortareStanga == true || testSortareDreapta == true || testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else {
            Serial.println("Se deplaseaza bratul de sortare cu ");
            Serial.print(parametru);
            Serial.print("pasi la dreapta!\n");
            nrPasiSortare = parametru;
            testSortareDreapta = true;
          }
        }
        break;

      case 'L' :
        if (testSortareStanga == true || testSortareDreapta == true || testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Se deplaseaza bratul de sortare cu ");
            Serial.print(parametru);
            Serial.print("pasi la stanga!\n");
            nrPasiSortare = parametru;
            testSortareStanga = true;
          }
        }
        break;

      case 'F' :

        if (testDeplasareInainte == true || testDeplasareInapoi == true || testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Se deplaseaza linia de deplasare cu  ");
            Serial.print(parametru);
            Serial.print("pasi inainte!\n");
            nrPasiDeplasare = parametru;
            testDeplasareInainte = true;
          }
        }
        break;

      case 'B' :
        if (testDeplasareInainte == true || testDeplasareInapoi == true || testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else
        {
          param = com.substring(1, com.length());
          parametru = param.toInt();
          if (parametru == 0)
          {
            Serial.println("Comanda este incorecta sau are ca parametru valoarea 0!Revizuiti comanda!");
          }
          else
          {
            Serial.println("Se deplaseaza linia de deplasare cu  ");
            Serial.print(parametru);
            Serial.print("pasi inapoi!\n");
            nrPasiDeplasare = parametru;
            testDeplasareInapoi = true;
          }
        }
        break;

      case 'P' :
        if (testProcesAutomat == true)
        {
          Serial.println("Sistemul nu poate efectua aceasta comanda deoarece componenta solicitata este ocupata!!!");
        }
        else {
          cutiiMiciEronate = 0;
          cutiiMariEronate = 0;
          cutiiMiciIncarcate = 0;
          cutiiMariIncarcate = 0;
          bileMiciDozate = 0;
          bileMariDozate = 0;
          Serial.write("Se efectueaza un proces automat...\n");
          sparamCutMici = com.substring(2, com.indexOf("b"));
          sparamBileMici = com.substring(com.indexOf("b") + 1, com.indexOf("C"));
          sparamCutMari = com.substring(com.indexOf("C") + 1, com.indexOf("B"));
          sparamBileMari = com.substring(com.indexOf("B") + 1, com.length());
          Serial.println("\n Cutii mici: ");
          Serial.print(sparamCutMici);
          Serial.println("\n Cutii mari: ");
          Serial.print(sparamCutMari);
          Serial.println("\n Bile in cutii mici: ");
          Serial.print(sparamBileMici);
          Serial.println("\n Bile in cutii mari: ");
          Serial.print(sparamBileMari);

          nrBileMari = sparamBileMari.toInt();
          nrBileMici = sparamBileMici.toInt();
          nrCutiiMici = sparamCutMici.toInt();
          nrCutiiMari = sparamCutMari.toInt();
          bileMiciDozate = nrBileMici;
          bileMariDozate = nrBileMari;
          testProcesAutomat = true;
        }
        break;

      default :
        Serial.write("Comanda introdusa nu exista! \n");
    }
  }
  if (afiseazaRaportInSerialMonitor == true)
  {
    Serial.println("Raportul ultimului proces efectuat:\n");
    Serial.println("Cutii mici incarcate:");
    Serial.println(cutiiMiciIncarcate);
    Serial.println("Cutii mici eronate:");
    Serial.println(cutiiMiciEronate);
    Serial.println("Bile incarcate in cutiile mici: ");
    Serial.println(bileMiciDozate);
    Serial.println("Cutii mari incarcate: ");
    Serial.println(cutiiMariIncarcate);
    Serial.println("Cutii mari eronate: ");
    Serial.println(cutiiMariEronate);
    Serial.println("Bile incarcate in cutiile mari: ");
    Serial.println(bileMariDozate);
    afiseazaRaportInSerialMonitor = false;
  }

  // listen for incoming clients
  EthernetClient client = server.available();
  if (client)
  {
    Serial.println("new client");
    userAutentificat = false;

    memset(linebuf, 0, sizeof(linebuf));
    charcount = 0;
    userAutentificat = false;

    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected())
    {
      if (client.available())
      {
        char c = client.read();
        linebuf[charcount] = c;
        if (charcount < sizeof(linebuf) - 1) charcount++;

        if (request.length() < 100)
        {
          //store characters to string
          request += c;
        }
        // Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank)
        {
          if (userAutentificat == true)
          {
            if (request.indexOf("ajax_sistemState") > 0)
            {
              GetAjaxData(client);
              request = "";
            }
            else if (request.indexOf("sistem.jpg") > 0)
            {
              webFile = SD.open("sistem.jpg");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if (request.indexOf("sistInc.png") > 0)
            {
              webFile = SD.open("sistInc.png");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if (request.indexOf("sistDepl.png") > 0)
            {
              webFile = SD.open("sistDepl.png");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if (request.indexOf("sistDoz.png") > 0)
            {
              webFile = SD.open("sistDoz.png");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if (request.indexOf("sistSort.png") > 0)
            {
              webFile = SD.open("sistSort.png");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if (request.indexOf("detectie.png") > 0)
            {
              webFile = SD.open("detectie.png");
              if (webFile) {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }
            else if ((request.indexOf("index.html") > 0))
            {
              paginaCurenta = "index";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("index.html");
            }
            else if ((request.indexOf("testare.html") > 0))
            {
              paginaCurenta = "testare";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("testare.html");
            }
            else if ((request.indexOf("info.html") > 0))
            {
              paginaCurenta = "info";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("info.html");
            }
            else if ((request.indexOf("manual.html") > 0))
            {
              paginaCurenta = "manual";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("manual.html");
            }
            else if (paginaCurenta.equals("index"))
            {
              paginaCurenta = "index";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("index.html");
            }
            else if (paginaCurenta.equals("testare"))
            {
              paginaCurenta = "testare";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("testare.html");
            }
            else if (paginaCurenta.equals("info"))
            {
              paginaCurenta = "info";
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("info.html");
            }
            else
            {
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connection: close");
              client.println();
              webFile = SD.open("index.html");
            }
            if (webFile) {
              while (webFile.available()) {
                client.write(webFile.read()); // send web page to client
              }
              webFile.close();
            }
          }
          else {
            SendAuthentificationPage(client);
          }
          break;
        }

        if (c == '\n')
        {
          // you're starting a new line
          currentLineIsBlank = true;
          //Serial.write(linebuf);
          if (strstr(linebuf, "Authorization: Basic") > 0 && strstr(linebuf, "YWRtaW46c3R1ZGVudA==") > 0 || strstr(linebuf, "ajax_sistemState") > 0)
            userAutentificat = true;
          memset(linebuf, 0, sizeof(linebuf));
          charcount = 0;
        }
        else if (c != '\r')
        {
          // you've gotten a character on the current line
          currentLineIsBlank = false;

        }
        ///////////////////// control arduino pins/////////////////////////

        if (request.indexOf("deplasareInainte") > 0)
        {
          if (testDeplasareInainte == true || testDeplasareInapoi == true || testProcesAutomat == true)
          {
            request = ""; //nu fac nimic
          }
          else
          {
            Serial.println("Se testeaza deplasarea inainte....");
            int functie = request.indexOf("deplasareInainte");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");

            if ((functie > 0) && (finalS > 0) && (startS > 0)) //verific daca exista atribute
            {
              Serial.println("\n Pasi inainte:");
              String atribute = request.substring(startS, finalS);
              String sparam = atribute.substring(13, finalS);
              Serial.println(sparam);
              int paramPasiInainte = sparam.toInt();
              nrPasiDeplasare = paramPasiInainte;
              request = "";
              testDeplasareInainte = true;
            }
          }
        }
        else if (request.indexOf("deplasareInapoi") > 0)
        {
          if (testDeplasareInainte == true || testDeplasareInapoi == true || testProcesAutomat == true)
          {
            request = "";
          }
          else
          {
            Serial.println("Se testeaza deplasarea inapoi....");
            int functie = request.indexOf("deplasareInapoi");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");
            if ((functie > 0) && (finalS > 0) && (startS > 0)) //verific daca exista atribute
            {
              Serial.println("\n Pasi inapoi:");
              String atribute = request.substring(startS, finalS);
              //Serial.print(atribute);
              String sparam = atribute.substring(12, finalS);
              Serial.println(sparam);
              int paramPasiInainte = sparam.toInt();
              nrPasiDeplasare = paramPasiInainte;
              request = "";
              testDeplasareInapoi = true;
            }
          }
        }
        else if (request.indexOf("sortareStanga") > 0)
        {
          if (testSortareStanga == true || testSortareDreapta == true || testProcesAutomat == true)
          {
            request = "";
          }
          else {

            Serial.println("Se testeaza sortarea stanga....");
            int functie = request.indexOf("sortareStanga");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");
            if ((functie > 0) && (finalS > 0) && (startS > 0)) //verific daca exista atribute
            {
              Serial.println("\n Pasi stanga:");
              String atribute = request.substring(startS, finalS);
              String sparam = atribute.substring(12, finalS);
              Serial.println(sparam);
              int paramPasiStanga = sparam.toInt();
              nrPasiSortare = paramPasiStanga;
              request = "";
              testSortareStanga = true;
            }
          }
        }
        else if (request.indexOf("sortareDreapta") > 0) {
          if (testSortareStanga == true || testSortareDreapta == true || testProcesAutomat == true)
          {
            request = "";
          }
          else {

            Serial.println("Se testeaza sortarea dreapta....");
            int functie = request.indexOf("sortareDreapta");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");
            if ((functie > 0) && (finalS > 0) && (startS > 0)) //verific daca exista atribute
            {
              Serial.println("\n Pasi dreapta:");
              String atribute = request.substring(startS, finalS);
              String sparam = atribute.substring(13, finalS);
              Serial.println(sparam);
              int paramPasiDreapta = sparam.toInt();
              nrPasiSortare = paramPasiDreapta;
              request = "";
              testSortareDreapta = true;
            }
          }
        }
        else if (request.indexOf("dozare") > 0)
        {

          if (testDozare == true || testProcesAutomat == true)
          {
            request = "";
          }
          else {
            Serial.println("Se testeaza dozarea....");
            int functie = request.indexOf("dozare");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");
            if ((functie > 0) && (finalS > 0) && (startS > 0)) //verific daca exista atribute
            {
              Serial.println("\n Parametru bile dozare:");
              String atribute = request.substring(startS, finalS);
              // Serial.println(atribute);
              String sparam = atribute.substring(12, finalS);
              Serial.println(sparam);
              int parametru = sparam.toInt();
              Serial.println(parametru);
              bileDozare = parametru;
              //stareDozare=0;
              //delayDozare=0;
              request = "";
              testDozare = true;
            }
          }
        }
        else if (request.indexOf("comandaAutomat") > 0)
        {
          if (testProcesAutomat == true)
          {
            request = "";
          }
          else {
            Serial.println("proces automat....");
            cutiiMiciEronate = 0;
            cutiiMariEronate = 0;
            cutiiMiciIncarcate = 0;
            cutiiMariIncarcate = 0;
            bileMiciDozate = 0;
            bileMariDozate = 0;
            ultimaCutieEronata = -1;

            int functie = request.indexOf("comandaAutomat");
            int finalS = request.indexOf("HTTP");
            int startS = request.indexOf("?");
            if ((functie > 0) && (finalS > 0) && (startS > 0))
            {
              Serial.println("\n Parametri:");
              String atribute = request.substring(startS, finalS);
              int indexBileMici = atribute.indexOf("nrBileMici");
              int indexBileMari = atribute.indexOf("nrBileMari");
              int indexCutiiMici = atribute.indexOf("cutiiMici");
              int indexcutiiMari = atribute.indexOf("cutiiMari");

              String sCutMici = atribute.substring(indexCutiiMici + 10, indexCutiiMici + 11);
              String sCutMari = atribute.substring(indexcutiiMari + 10, indexcutiiMari + 11);
              String sBileMici = atribute.substring(indexBileMici + 11, indexBileMici + 12);
              String sBileMari = atribute.substring(indexBileMari + 11, indexBileMari + 12);
              Serial.println(sCutMici);
              Serial.println(sCutMari);
              Serial.println(sBileMici);
              Serial.println(sBileMari);
              int bileMici = 0;
              int bileMari = 0;
              int cutiiMici = 0;
              int cutiiMari = 0;
              bileMici = sBileMici.toInt();
              bileMari = sBileMari.toInt();
              cutiiMici = sCutMici.toInt();
              cutiiMari = sCutMari.toInt();

              nrBileMici = bileMici;
              nrBileMari = bileMari;
              bileMiciDozate = nrBileMici;
              bileMariDozate = nrBileMari;
              nrCutiiMici = cutiiMici;
              nrCutiiMari = cutiiMari;
              request = "";
              testProcesAutomat = true;
            }
          }
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
    request = "";
  }
  //actualizez starea sistemului
  delay(1);
  ActualizareSistem();

}
void ActualizareSistem() {
  if (testProcesAutomat == true)
  {
    tratareProcesAutomat();
  }
  else
  {
    if (testDeplasareInainte == true)
    {
      tratareTestDeplasareInainte();
    }
    if (testDeplasareInapoi == true)
    {
      tratareTestDeplasareInapoi();
    }
    if (testSortareStanga == true)
    {
      tratareTestSortareStanga();
    }
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testDozare == true)
    {
      tratareTestDozare();
    }
    if (testIncarcareCMare == true)
    {
      tratareIncarcareCMare();
    }
    if (testIncarcareCMica == true)
    {
      tratareIncarcareCMica();
    }
  }
}

void tratareProcesAutomat()
{
  if (nrCutiiMici > 0)
  {
    tratareCicluProces(0); //ciclu proces pentru cutie mica
  }
  else if (nrCutiiMari > 0)
  {
    tratareCicluProces(1);
  }
  else {
    afiseazaRaport = true;
    afiseazaRaportInSerialMonitor = true;
    testProcesAutomat = false;
    nrCutiiMici = 0;
    nrCutiiMari = 0;
    nrBileMici = 0;
    nrBileMari = 0;
    stareProces = 0;
    delayProces = 0;
    eCutiePeLinie = false;
    gasitCutie = false;
    capatLinieDeplasare = false;
    ultimaCutieEronata = -1;
  }
}

void   tratareCicluProces(int tipCutie)
{
  if (stareProces == 0)
  {
    initialSensorValue = analogRead(A0);
    Serial.println(initialSensorValue);
    if (tipCutie == 1 && ultimaCutieEronata != 1)
    {
      nrPasiSortare = 350;
      testSortareDreapta = true;
      stareProces = 2;
    }
    else
    {
      stareProces = 2;
    }
  }
  else if (stareProces == 2)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    capatLinieDeplasare = eCapatLinieDeplasare();
    if (capatLinieDeplasare == false)
    {
      stareProces = 3;
    }
    else
    {
      if (tipCutie == 0)
      {
        testIncarcareCMica = true;
      }
      else
      {
        testIncarcareCMare = true;
      }
      stareProces = 4;
    }
  }
  else if (stareProces == 3)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (capatLinieDeplasare == false)
    { //fac un pas inapoi
      pasDeplasare = (pasDeplasare + 1) % 4;
      digitalWrite(deplasare1, vDeplasare[pasDeplasare][0]);
      digitalWrite(deplasare2, vDeplasare[pasDeplasare][1]);
      digitalWrite(deplasare3, vDeplasare[pasDeplasare][2]);
      digitalWrite(deplasare4, vDeplasare[pasDeplasare][3]);
      capatLinieDeplasare = eCapatLinieDeplasare();
      delay(4);
    }
    else
    {
      digitalWrite(deplasare1, LOW);
      digitalWrite(deplasare2, LOW);
      digitalWrite(deplasare3, LOW);
      digitalWrite(deplasare4, LOW);
      if (tipCutie == 0)
      {
        testIncarcareCMica = true;
      }
      else
      {
        testIncarcareCMare = true;
      }
      stareProces = 4;
    }
  }
  else if (stareProces == 4)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testIncarcareCMica == true)
    {
      tratareIncarcareCMica();
    }
    else if (testIncarcareCMare == true)
    {
      tratareIncarcareCMare();
    }
    else
    {
      stareProces = 5;
      delayProces = 200;
    }
  }
  else if (stareProces == 5)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (delayProces == 0)
    {
      stareProces = 6;
      nrPasiDeplasare = 2000;
      testDeplasareInainte = true;
    }
    else
    {
      delayProces--;
    }
  }
  else if (stareProces == 6)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testDeplasareInainte == true)
    {
      tratareTestDeplasareInainte();
      eCutiePeLinie = detectareCutie();
      if (eCutiePeLinie)
        gasitCutie = true;
    }
    else
    {
      stareProces = 7;
    }
  }
  else if (stareProces == 7)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (gasitCutie == false)
    {
      if (tipCutie == 0)
      {
        ultimaCutieEronata = 0;
        cutiiMiciEronate++;
      }
      else
      {
        ultimaCutieEronata = 1;
        cutiiMariEronate++;
      }
      stareProces = -1;
    }
    else
    {
      ultimaCutieEronata = -1;
      stareProces = 8;
      testDeplasareInainte = true;
      nrPasiDeplasare = 1230;
    }
  }
  else if (stareProces == -1) {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    else
      stareProces = 0;
  }
  else if (stareProces == 8)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testDeplasareInainte == true)
    {
      tratareTestDeplasareInainte();
    }
    else
    {
      delayProces = 1000;
      stareProces = 9;
    }
  }
  else if (stareProces == 9)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (delayProces == 0)
    {
      stareProces = 10;
      testDozare = true;
      if (tipCutie == 0)
      {
        bileDozare = nrBileMici;
      }
      else
      {
        bileDozare = nrBileMari;
      }
    }
    else
    {
      delayProces--;
    }
  }
  else if (stareProces == 10)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testDozare == true)
    {
      tratareTestDozare();
    }
    else if (testDozare == false && testSortareDreapta == false)
    {
      stareProces = 11;
      delayProces = 1000;
    }
  }
  else if (stareProces == 11)

  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (delayProces == 0)
    {
      stareProces = 12;
      nrPasiDeplasare = 1250;
      testDeplasareInainte = true;
    }
    else
    {
      delayProces--;
    }
  }
  else if (stareProces == 12)
  {
    if (testSortareDreapta == true)
    {
      tratareTestSortareDreapta();
    }
    if (testDeplasareInainte == true)
    {
      tratareTestDeplasareInainte();
    }
    else
      stareProces = 13;
  }
  else if (stareProces == 13)
  {
    if (tipCutie == 0)
    {
      stareProces = 14;
      nrPasiSortare = 350;
      testSortareDreapta = true;
    }
    else
    { stareProces = 18;
      nrPasiSortare = 350;
      testSortareStanga = true;
    }
  }
  else if (stareProces == 14)  //sortare cutie mica
  {
    if (testSortareDreapta == true)
    {
      // Serial.println("am intrat in sortare");
      tratareTestSortareDreapta();
    }
    else {
      delayProces = 2000;
      stareProces = 15;
    }
  }
  else if (stareProces == 15)
  {
    if (delayProces == 0)
    {
      stareProces = 20;
      testSortareStanga = true;
      nrPasiSortare = 350;
      nrPasiDeplasare = 4500;
      testDeplasareInapoi = true;
    }
    else
    {
      delayProces--;
    }
  }
  else if (stareProces == 18)
  {
    if (testSortareStanga == true)
    {
      tratareTestSortareStanga();
    }
    else {
      delayProces = 2000;
      stareProces = 19;
    }
  }
  else if (stareProces == 19) ///verific daca pot scoate starea!!!!
  {
    if (delayProces == 0)
    {
      stareProces = 20;
      nrPasiDeplasare = 4500;
      testDeplasareInapoi = true;
    }
    else
    {
      delayProces--;
    }
  }
  else if (stareProces == 20)
  {
    if (testSortareStanga == true)
    {
      tratareTestSortareStanga();
    }
    if (testDeplasareInapoi == true)
    {
      tratareTestDeplasareInapoi();
    }
    if (testDeplasareInapoi == false && testSortareStanga == false) {
      stareProces = 21;
    }
  }
  else if (stareProces == 21)
  {
    if (tipCutie == 1)
    {
      cutiiMariIncarcate++;
      nrCutiiMari--;
    }
    else {
      cutiiMiciIncarcate++;
      nrCutiiMici--;
    }
    stareProces = 0;
    delayProces = 0;
    eCutiePeLinie = false;
    gasitCutie = false;
  }
}
bool detectareCutie()
{
  // read the input on analog pin 0:
  int sensorValue = analogRead(A0);
  Serial.println(sensorValue);
  if (sensorValue > initialSensorValue + 200)
  {
    return true;
  }
  else
  {
    return false;
  }
}

bool eCapatLinieDeplasare()
{
  int valoareSenzor = digitalRead(pinSenzorDetectie);
  if (valoareSenzor == LOW)
  {
    return true;  //s-a ajuns la capatul liniei
  }
  else
  {
    return false;
  }
}

void tratareIncarcareCMare()
{
  if (stareIncarcare == 0)
  {
    digitalWrite(pinCutMare2, HIGH);
    delayIncarcare = 200;
    stareIncarcare = 1;
  }
  else if (stareIncarcare == 1)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 2;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 2)
  {
    digitalWrite(pinCutMare1, HIGH);
    delayIncarcare = 500;
    stareIncarcare = 3;
  }
  else if (stareIncarcare == 3)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 4;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 4)
  {
    digitalWrite(pinCutMare1, LOW);
    delayIncarcare = 200;
    stareIncarcare = 5;
  }
  else if (stareIncarcare == 5)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 6;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 6)
  {
    digitalWrite(pinCutMare2, LOW);
    delayIncarcare = 200;
    stareIncarcare = 7;
  }
  else if (stareIncarcare == 7)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 8;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 8)
  {
    digitalWrite(pinCutMare1, HIGH);
    delayIncarcare = 500;
    stareIncarcare = 9;
  }
  else if (stareIncarcare == 9)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 10;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 10)
  {
    digitalWrite(pinCutMare1, LOW);
    testIncarcareCMare = false;
    stareIncarcare = 0;
  }
}

void tratareIncarcareCMica() {
  if (stareIncarcare == 0)
  {
    digitalWrite(pinCutMica2, HIGH);
    delayIncarcare = 300;
    stareIncarcare = 1;
  }
  else if (stareIncarcare == 1)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 2;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 2)
  {
    digitalWrite(pinCutMica1, HIGH);
    delayIncarcare = 500;
    stareIncarcare = 3;
  }
  else if (stareIncarcare == 3)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 4;
    }
    else
    {
      delayIncarcare--;
    }
  }
  if (stareIncarcare == 4)
  {
    digitalWrite(pinCutMica1, LOW);
    delayIncarcare = 300;
    stareIncarcare = 5;
  }
  else if (stareIncarcare == 5)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 6;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 6)
  {
    digitalWrite(pinCutMica2, LOW);
    delayIncarcare = 300;
    stareIncarcare = 7;
  }
  else if (stareIncarcare == 7)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 8;
    }
    else
    {
      delayIncarcare--;
    }
  }
  if (stareIncarcare == 8)
  {
    digitalWrite(pinCutMica1, HIGH);
    delayIncarcare = 500;
    stareIncarcare = 9;
  }
  else if (stareIncarcare == 9)
  {
    if (delayIncarcare == 0)
    {
      stareIncarcare = 10;
    }
    else
    {
      delayIncarcare--;
    }
  }
  else if (stareIncarcare == 10)
  {
    digitalWrite(pinCutMica1, LOW);
    testIncarcareCMica = false;
    stareIncarcare = 0;
  }
}

void tratareTestDozare() {
  if (bileDozare > 0)
  {
    if (stareDozare == 0)
    {
      digitalWrite(pinDozare, LOW);
      delayDozare = 500;
      stareDozare = 1;
    }
    else if (stareDozare == 1)
    {
      if (delayDozare == 0)
      {
        stareDozare = 2;
      }
      else
      { delayDozare--;
      }
    }
    else if (stareDozare == 2)
    {
      digitalWrite(pinDozare, HIGH);
      delayDozare = 500;
      stareDozare = 3;
    }
    else if (stareDozare == 3)
    {
      if (delayDozare == 0)
      {
        stareDozare = 0;
        bileDozare--;
      }
      else
      {
        delayDozare--;
      }
    }
  }
  else
  {
    testDozare = false;
    stareDozare = 0;
    delayDozare = 0;
  }
}

void tratareTestDeplasareInainte()
{
  if (nrPasiDeplasare > 0)
  {
    pasDeplasare = (pasDeplasare - 1) % 4;
    if (pasDeplasare < 0)
    {
      pasDeplasare = pasDeplasare + 4;
    }
    digitalWrite(deplasare1, vDeplasare[pasDeplasare][0]);
    digitalWrite(deplasare2, vDeplasare[pasDeplasare][1]);
    digitalWrite(deplasare3, vDeplasare[pasDeplasare][2]);
    digitalWrite(deplasare4, vDeplasare[pasDeplasare][3]);
    delay(4);
    nrPasiDeplasare = nrPasiDeplasare - 1;
  }
  else
  {
    testDeplasareInainte = false;
    digitalWrite(deplasare1, LOW);
    digitalWrite(deplasare2, LOW);
    digitalWrite(deplasare3, LOW);
    digitalWrite(deplasare4, LOW);
  }
}
void tratareTestDeplasareInapoi()
{
  if (nrPasiDeplasare > 0)
  {
    pasDeplasare = (pasDeplasare + 1) % 4;
    digitalWrite(deplasare1, vDeplasare[pasDeplasare][0]);
    digitalWrite(deplasare2, vDeplasare[pasDeplasare][1]);
    digitalWrite(deplasare3, vDeplasare[pasDeplasare][2]);
    digitalWrite(deplasare4, vDeplasare[pasDeplasare][3]);
    nrPasiDeplasare = nrPasiDeplasare - 1;
    delay(4);
  }
  else
  {
    testDeplasareInapoi = false;
    digitalWrite(deplasare1, LOW);
    digitalWrite(deplasare2, LOW);
    digitalWrite(deplasare3, LOW);
    digitalWrite(deplasare4, LOW);
  }
}

void tratareTestSortareStanga()
{
  if (nrPasiSortare > 0)
  {
    if (stareSortare == 0)
    {
      digitalWrite(enableSortare, HIGH);
      stareSortare = 1;
    }
    else if (stareSortare == 1)
    {
      pasSortare = (pasSortare - 1) % 4;
      if (pasSortare < 0)
      {
        pasSortare = pasSortare + 4;
      }
      digitalWrite(sortare1, vSortare[pasSortare][0]);
      digitalWrite(sortare2, vSortare[pasSortare][1]);
      delaySortare = 20;
      stareSortare = 2;
    }
    else if (stareSortare == 2)
    {
      if (delaySortare == 0)
      {
        nrPasiSortare = nrPasiSortare - 1;
        stareSortare = 0;
      }
      else
      {
        delaySortare--;
      }
    }
  }
  else
  {
    testSortareStanga = false;
    stareSortare = 0;
    digitalWrite(enableSortare, LOW);
  }
}
void tratareTestSortareDreapta()
{
  if (nrPasiSortare > 0)
  {
    if (stareSortare == 0)
    {
      digitalWrite(enableSortare, HIGH);
      stareSortare = 1;
    }
    else if (stareSortare == 1)
    {
      pasSortare = (pasSortare + 1) % 4;
      digitalWrite(sortare1, vSortare[pasSortare][0]);
      digitalWrite(sortare2, vSortare[pasSortare][1]);
      delaySortare = 20;
      stareSortare = 2;
    }
    else if (stareSortare == 2)
    {
      if (delaySortare == 0)
      {
        nrPasiSortare = nrPasiSortare - 1;
        stareSortare = 0;
      }
      else
      {
        delaySortare--;
      }
    }
  }
  else
  {
    testSortareDreapta = false;
    stareSortare = 0;
    digitalWrite(enableSortare, LOW);
  }
}

void GetAjaxData(EthernetClient cl)
{
  bool sistemOcupat = false;
  if (testProcesAutomat == true)
  { sistemOcupat = true;
    cl.print("<h3> Sistemul efectueaza un proces automat</h3> <br>");
  }
  if (testIncarcareCMica == true)
  {
    sistemOcupat = true;
    cl.print("<h4> Sistemul incarca o cutie mica</h5> <br>");
  }
  if (testIncarcareCMare == true)
  { sistemOcupat = true;
    cl.print("<h4> Sistemul incarca o cutie mare</h4> <br>");
  }
  if (testSortareStanga)
  { sistemOcupat = true;
    cl.print("<h4> Sistemul se afla in faza de sortare spre stanga</h4> <br>");
  }
  if (testSortareDreapta)
  { sistemOcupat = true;
    cl.print("<h4> Sistemul se afla in faza de sortare spre dreapta</h4> <br>");
  }
  if (testDeplasareInainte)
  {
    sistemOcupat = true;
    cl.print("<h4> Sistemul se afla in faza de deplasare a liniei de productie spre inainte</h4> <br>");
  }
  if (testDeplasareInapoi)
  { sistemOcupat = true;
    cl.print("<h4> Sistemul se afla in faza de deplasare a liniei de productie spre inapoi</h4> <br>");
  }
  if (testDozare)
  { sistemOcupat = true;
    cl.print("<h4> Sistemul se afla in faza de dozare</h4> <br>");
  }
  if (sistemOcupat == false)
  {
    cl.print("<h4> Sistemul asteapta comenzi!</h4> ");
  }

  if ((sistemOcupat == false) && (afiseazaRaport == true))
  {
    cl.println("<h3>Raportul ultimului proces efectuat:</h3>");
    cl.println("<p><b>Cutii mici incarcate: </b>");
    cl.print(cutiiMiciIncarcate);
    cl.println("</p>");
    cl.println("<p><b>Cutii mici eronate: </b>");
    cl.print(cutiiMiciEronate);
    cl.println("</p>");
    cl.println("<p><b>Bile incarcate in cutiile mici: </b>");
    cl.print(bileMiciDozate);
    cl.println("</p>");
    cl.println("<p><b>Cutii mari incarcate: </b>");
    cl.print(cutiiMariIncarcate);
    cl.println("</p");
    cl.println("<p><b>Cutii mari eronate: </b>");
    cl.print(cutiiMariEronate);
    cl.println("</p>");
    cl.println("<p><b>Bile incarcate in cutiile mari: </b>");
    cl.print(bileMariDozate);
    cl.println("</p>");
  }
  else
  {
    afiseazaRaport = false;
  }
}

